<?php

/**
 * registro_gastos actions.
 *
 * @package    controlComisiones
 * @subpackage registro_gastos
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class registro_gastoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_REGISTRO_GASTO_V',
        'COM_PAGO_EGRESO',
        'COM_CUENTA_V',
        'COM_RESOLUCION',
        'COM_COMISION',
        'PROYECTOS',
        'COM_TERCERO',
        'TIPOS_COMISION'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'COM_PAGO_EGRESO' =>
        array(
            'id_pago_egreso' => 'COM_REGISTRO_GASTO_V'
        ),
        'COM_CUENTA_V' =>
        array(
            'id_cuenta' => 'COM_PAGO_EGRESO'
        )
        , 'COM_RESOLUCION' =>
        array(
            'id_resolucion' => 'COM_CUENTA_V'
        ),
        'COM_COMISION' =>
        array(
            'id_comision' => 'COM_RESOLUCION'
        ),
        'PROYECTOS' =>
        array(
            'id_proyecto-id' => 'COM_COMISION'
        ),
        'TIPOS_COMISION' =>
        array(
            'id_tipo_comision' => 'COM_COMISION'
        ),
        'COM_TERCERO' =>
        array(
            'id_tercero' => 'COM_CUENTA_V'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_REGISTRO_GASTO_V' =>
        array(
            'id_registro_gasto' => 'id_registro_gasto',
            'id_pago_egreso' => 'id_pago_egreso',
            'id_anhos' => 'id_anhos',
            'id_elementos_gasto' => 'id_elementos_gasto',
            'id_mae_ter' => 'id_mae_ter',
            'no_documento' => 'no_documento',
            'fecha_gasto' => 'fecha_gasto',
            'vr_bruto' => 'vr_bruto',
            'vr_iva' => 'vr_iva',
            'vr_retencion' => 'vr_retencion',
            'vr_neto' => 'vr_neto',
            'observaciones' => 'observaciones',
            'num_doc_benef' => 'num_doc_benef',
            'razon_soc_benef' => 'razon_soc_benef',
            'codigo_gasto' => 'codigo_gasto',
            'descripcion_gasto' => 'descripcion_gasto',
            'codigo_gasto,||, - ,||,descripcion_gasto' => 'completo_gasto'
        ),
        'COM_PAGO_EGRESO' =>
        array(
            'id_cuenta' => 'id_cuenta',
            'no_pago' => 'no_pago',
            'fecha_pago' => 'fecha_pago',
            'valor_neto' => 'valor_neto'
        ),
        'COM_CUENTA_V' =>
        array(
            'id_resolucion' => 'id_resolucion',
            'no_cuenta' => 'no_cuenta',
            'fecha_cuenta' => 'fecha_cuenta',
            'id_tercero' => 'id_tercero',
            'valor' => 'valor'
        ),
        'COM_RESOLUCION' =>
        array(
            'id_comision' => 'id_comision',
            'no_resolucion' => 'no_resolucion',
            'fecha_resolucion' => 'fecha_resolucion',
            'id_anhos' => 'id_anhos_resol',
            'estado' => 'estado_resol'
        ),
        'COM_COMISION' =>
        array(
            'no_comision' => 'no_comision',
            'fecha_solicitud' => 'fecha_solicitud',
            'objeto' => 'objeto',
            'agenda' => 'agenda',
            'fecha_inicio' => 'fecha_inicio_comi',
            'fecha_fin' => 'fecha_fin_comi'
        ),
        'PROYECTOS' =>
        array(
            'descripcion' => 'descripcion_cm',
            'codigo' => 'codigo_cm'
        ),
        'INTERCEROS_V' =>
        array(
            'num_doc' => 'num_doc',
            'nombre' => 'nombre'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'id_anhos', 'codigo_cm', 'fecha_gasto', 'codigo_gasto'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_REGISTRO_GASTO_V' =>
        array(
            'id_registro_gasto,a' => array('!=' => array(-1)),
            'id_registro_gasto,b' => array('=' => array('id_cumplido')),
            'id_pago_egreso' => array('=' => array('id_pago_egreso')),
            'fecha_gasto' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'id_anhos' => array('=' => array('id_anhos')),
            'id_mae_ter' => array('=' => array('id_mae_ter')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'COM_CUENTA_V' =>
        array(
            'id_tercero' => array('=' => array('id_tercero')),
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_registro_gasto'; //identificador de la tabla
    protected $id_names = array('id_registro_gasto'); //llave primaria
    protected $field_names = array('id_pago_egreso', 'id_anhos', 'id_elementos_gasto', 'id_mae_ter', 'no_documento', 'fecha_gasto', 'vr_bruto', 'vr_iva',
        'vr_retencion', 'vr_neto', 'observaciones'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_REGISTRO_GASTO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_registro_gasto'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;


        $id_pago_egreso = $request['id_pago_egreso'];
        $id_elementos_gasto = $request['id_elementos_gasto'];
        $valor_bruto = $request['vr_bruto'];
        $valor_iva = $request['vr_iva'];
        $fecha_gasto = $request['fecha_gasto'];
        $valor_compara = $valor_bruto + $valor_iva;

        /*
         *  Validar la operación, ya sea por SQL
         */

        //1. Validar que la fecha del gasto se encuentre entre las fechas del cumplido

        $sql = <<<EOD
select 

case when to_date('$fecha_gasto','YYYY-MM-DD') between tab0.fecha_inicio and tab0.fecha_fin then 1 else 0 end VALIDA

from com_cumplido tab0

WHERE tab0.id_pago_egreso = $id_pago_egreso
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $valida = $records[0]['valida'];

        if ($valida == 0) {

            $errors['mensaje'] = "La fecha del Gasto no se encuentra en el rango de fechas del cumplido";
            $errors['servicio'] = "registro_gasto";
        }

        //2. Validar que el valor del gasto no supere el valor aprobado en la comision

        $sql = <<<EOD
select id_objeto_gasto from pr_elementos_gasto where id_elementos_gasto = $id_elementos_gasto

EOD;

        $records = CN_TABLE::executeSQL($sql);

        $id_objeto_gasto = $records[0]['id_objeto_gasto'];


        $sql = <<<EOD
select tab0.valor_cuenta - tab0.valor as saldo

from(
select tab0.*,nvl(tab1.valor_cuenta,0) valor_cuenta,nvl(tab3.valor,0) valor

from com_pago_egreso tab0
left join com_deta_cuenta tab1 ON tab1.id_cuenta = tab0.id_cuenta

left join(
select tab0.id_pago_egreso,tab0.id_objeto_gasto, sum(nvl(tab0.valor,0)) valor

from(

select tab0.id_pago_egreso,tab1.id_objeto_gasto,nvl(tab0.vr_bruto,0) + nvl(tab0.vr_iva,0) valor

from com_registro_gasto tab0
join pr_elementos_gasto tab1 ON tab1.id_elementos_gasto = tab0.id_elementos_gasto

)tab0

group by tab0.id_pago_egreso,tab0.id_objeto_gasto

)tab3 ON tab3.id_pago_egreso = tab0.id_pago_egreso and tab3.id_objeto_gasto = tab1.id_obj_gasto

where tab1.id_obj_gasto = $id_objeto_gasto and tab0.id_pago_egreso = $id_pago_egreso

)tab0

EOD;

        $records = CN_TABLE::executeSQL($sql);

        $saldo = $records[0]['saldo'];



        if ($saldo < $valor_compara) {

            $errors['mensaje'] = "El valor del gasto es mayor al saldo.";
            $errors['servicio'] = "registro_gasto";
        }

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        $id_registro_gasto = $request['id_registro_gasto'];

        $sql = <<<EOD
select count(tab0.id_registro_gasto) cantidad

from com_registro_gasto tab0
join pr_elementos_gasto tab1 ON tab1.id_elementos_gasto = tab0.id_elementos_gasto
where tab1.viatico =  1 and tab0.id_registro_gasto =  $id_registro_gasto
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $cantidad = $records[0]['cantidad'];

        if ($cantidad == 1) {

            $sql = <<<EOD
select count(tab0.id_registro_gasto) cantidad

from com_registro_gasto tab0
join pr_elementos_gasto tab1 ON tab1.id_elementos_gasto = tab0.id_elementos_gasto
where tab1.viatico =  0 and tab0.id_registro_gasto =  $id_registro_gasto
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $cantidad = $records[0]['cantidad'];

            if ($cantidad > 0) {

                $errors['mensaje'] = "Se deben eliminar los demas gastos antes de eliminar el registro de viaticos.";
                $errors['servicio'] = "registro_gasto";
            }
        }


        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;


        $id_registro_gasto = $request['id_registro_gasto'];

        $sql = <<<EOD
select id_pago_egreso from com_registro_gasto where id_registro_gasto = $id_registro_gasto
EOD;

        $records = CN_TABLE::executeSQL($sql);
        $id_pago_egreso = $records[0]['id_pago_egreso'];


        $sql = <<<EOD
SELECT count(tab0.id_radicado) cantidad

from com_radicado tab0
where tab0.id_pago_egreso = $id_pago_egreso
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $cantidad = $records[0]['cantidad'];

        if ($cantidad > 0) {

            $errors['mensaje'] = "Ya se ha registrado radicado para esta comision, no se puede editar.";
            $errors['servicio'] = "cumplido";
        }

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
